------------------------------------------------------------------------------------
--Name:			[简体征服][活动脚本]剧情测试脚本
--Creator:		林静
--Created:		2019/03/30
------------------------------------------------------------------------------------

local LuaSceneScript = {
    -- 测试用脚本，请根据实际数据修改
    [1] = { file="Script/DemoScript.lua", },
	[2] = { file="Script/WolfWarriors.lua", },
	[3] = { file="Script/PantherWarriors.lua", },	
	[4] = { file="Script/LionWarriors.lua", },
	[5] = { file="Script/TigerWarriors.lua", },
	[6] = { file="Script/KingWarriors.lua", },
	[7] = { file="Script/BaibingSpectrum.lua", },
	[8] = { file="Script/SpringFestivalMainLine2020First.lua", },
	[9] = { file="Script/ValDayEnterPrison.lua", },
	[10] = { file="Script/ValDayKillMonster.lua", },
	[11] = { file="Script/ValentinePart2One.lua", },
	[12] = { file="Script/ValentinePart2Tow.lua", },
	[13] = { file="Script/ValentinePart2Three.lua", },
	[14] = { file="Script/ValentinePart2TowFour.lua", },
	[15] = { file="Script/ValentinePart2TowFive.lua", },
	[16] = { file="Script/ValentinePart2TowSix.lua", },
	[17] = { file="Script/ValentinePart2TowSeven.lua", },
    	[18] = { file="Script/NinjaAwakeForward/Chapter1Start.lua"},
   	[19] = { file="Script/NinjaAwakeForward/Chapter1End.lua"},
   	[20] = { file="Script/NinjaAwakeForward/Chapter2Start.lua"},
   	[21] = { file="Script/NinjaAwakeForward/Chapter2End.lua"},
    	[22] = { file="Script/NinjaAwakeForward/Chapter3.lua"},
	[23] = { file="Script/NinjaQuest/NinjaQuestPlot1.lua", },
	[24] = { file="Script/NinjaQuest/NinjaQuestPlot2.lua", },
	[25] = { file="Script/NinjaQuest/NinjaQuestPlot3.lua", },
	[26] = { file="Script/NinjaQuest/NinjaQuestPlot4.lua", },
	[27] = { file="Script/NinjaQuest/NinjaQuestPlot5.lua", },
	[28] = { file="Script/NinjaQuest/NinjaQuestPlot6.lua", },
	[29] = { file="Script/NinjaQuest/NinjaQuestPlot7.lua", },
	[30] = { file="Script/NinjaQuest/NinjaQuestPlot8.lua", },
	[31] = { file="Script/NinjaQuest/NinjaQuestPlot9.lua", },
	[32] = { file="Script/NinjaQuest/NinjaQuestPlot10.lua", },
	[33] = { file="Script/NinjaQuest/NinjaQuestPlot11.lua", },
	[34] = { file="Script/NinjaQuest/NinjaQuestPlot12.lua", },
	[35] = { file="Script/NinjaQuest/NinjaQuestPlot13.lua", },
	[36] = { file="Script/NinjaQuest/NinjaQuestPlot14.lua", },
	[37] = { file="Script/NinjaQuest/NinjaQuestPlot15.lua", },
	[38] = { file="Script/NinjaQuest/NinjaQuestPlot16.lua", },
	[39] = { file="Script/NinjaQuest/NinjaQuestPlot17.lua", },
	[40] = { file="Script/NinjaQuest/NinjaQuestPlot18.lua", },
	[41] = { file="Script/NinjaQuest/NinjaQuestPlot19.lua", },
	[42] = { file="Script/NinjaQuest/NinjaQuestPlot20.lua", },
	[43] = { file="Script/StrengthCopy.lua", },
	[44] = { file="Script/Aniversary2020Guide.lua", },
	[45] = { file="Script/Aniversary2020GuideTwo.lua", },
	[46] = { file="Script/Aniversary2020GuideThree.lua", },
	[47] = { file="Script/Aniversary2020GuideTwoPassion.lua", },
	[48] = { file="Script/Aniversary2020GuideThreePassion.lua", },
	[49] = { file="Script/ChildrenDay/2020/ChildrenDayMainNpc.lua", },
	[50] = { file="Script/ChildrenDay/2020/ChildrenDayMainMap.lua", },
	[51] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick1.lua", },
	[52] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick2.lua", },
	[53] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick3.lua", },
	[54] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick4.lua", },
	[55] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick5.lua", },
	[56] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick6.lua", },
	[57] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick7.lua", },
	[58] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick8.lua", },
	[59] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick9.lua", },
	[60] = { file="Script/ChildrenDay/2020/ChildrenHideAndSick10.lua", },
	[61] = { file="Script/SummerActivity2020.lua", },
	[62] = { file="Script/QixiFestivalNPC.lua", },
	[63] = { file="Script/MidAutumnNpcScript.lua", },
	[69] = { file="Script/Halloween/2020/HalloweenNightmare4.lua", },
	[70] = { file="Script/Halloween/2020/HalloweenNightmare6.lua", },
	[71] = { file="Script/Halloween/2020/HalloweenMain.lua", },
	[72] = { file="Script/Halloween/2020/NightMarePartOne.lua", },
	[73] = { file="Script/Halloween/2020/Halloween2020Nightmare1.lua", },
	[74] = { file="Script/Halloween/2020/Halloween2020Nightmare2.lua", },
	[75] = { file="Script/Halloween/2020/Halloween2020Nightmare3.lua", },
	[76] = { file="Script/Halloween/2020/Halloween2020Nightmare4.lua", },
	[77] = { file="Script/Halloween/2020/Halloween2020Nightmare5.lua", },
	[78] = { file="Script/Halloween/2020/Halloween2020Nightmare6.lua", },
	[79] = { file="Script/Halloween/2020/Halloween2020Nightmare7.lua", },
	[80] = { file="Script/Halloween/2020/Halloween2020Nightmare8.lua", },
	[81] = { file="Script/Halloween/2020/Halloween2020Nightmare9.lua", },
	[82] = { file="Script/Halloween/2020/Halloween2020Nightmare10.lua", },
	[84] = { file="Script/DoubleElevenPreheat2020.lua", },
	[91] = { file="Script/DoubleElevenPreheat2020Nogift.lua", },
	[83] = { file="Script/Thanksgiving/ThanksgivingMainNpc.lua", },
	[85] = { file="Script/Thanksgiving/SecondaryNPCScript.lua", },
	[86] = { file="Script/WarriorAwakens/WarriorAwakens3Guide.lua", },
	[87] = { file="Script/WarriorAwakens/WarriorAwakens2.lua",},
	[89] = { file="Script/WarriorAwakens/WarriorAwakens1.lua", },
	[88] = { file="Script/WarriorAwakens/WarriorAwakensPlot4.lua", },
	[97] = { file="Script/WarriorAwakens/WarriorAwakens4EnterMap.lua", },
	[98] = { file="Script/WarriorAwakens/WarriorAwakens4ChoiceBoss.lua", },
	[99] = { file="Script/WarriorAwakens/WarriorAwakens4BossDiePlot.lua", },
	[90] = { file="Script/Thanksgiving/SecondaryNPCScriptNoGift.lua", },
	[92] = { file="Script/ChristmasNPC.lua", },
	[93] = { file="Script/ChristmasMap.lua", },
	[110] = { file="Script/WarriorAwaken/WarriorAwakenPlot1.lua", },
	[111] = { file="Script/WarriorAwaken/WarriorAwakenPlot2.lua", },
	[94] = { file="Script/WarriorAwaken/WarriorAwakenPlot3.lua", },
	[95] = { file="Script/WarriorAwaken/WarriorAwakenPlot4.lua", },
	[96] = { file="Script/WarriorAwaken/WarriorAwakenPlot5.lua", },
	[101] = { file="Script/WarriorAwaken/WarriorAwakenPlot6.lua", },
	[102] = { file="Script/WarriorAwaken/WarriorAwakenAfter1.lua", },
	[103] = { file="Script/WarriorAwaken/WarriorAwakenAfter2.lua", },
	[104] = { file="Script/WarriorAwaken/WarriorAwakenAfter3.lua", },
	[105] = { file="Script/WarriorAwaken/WarriorAwakenAfter4.lua", },
	[106] = { file="Script/WarriorAwaken/WarriorAwakenAfter5.lua", },
	[107] = { file="Script/SpringFestival/2021/SpringFestival1.lua", },
	[108] = { file="Script/SpringFestival/2021/ZodiacPeachMansion.lua", },
	[109] = { file="Script/SpringFestival/2021/SpringFestivalLionDance.lua", },
	[112] = { file="Script/FebPromotion2021.lua", },
	[113] = { file="Script/ValentinesDay/2021/ValentinesDayNPC.lua", },
	[114] = { file="Script/ValentinesDay/2021/WhiteValentinesDays2021Plot1.lua", },
	[115] = { file="Script/ValentinesDay/2021/WhiteValentinesDays2021Plot2.lua", },
	[116] = { file="Script/ValentinesDay/2021/WhiteValentinesDays2021Plot3.lua", },
	[117] = { file="Script/ValentinesDay/2021/WhiteValentinesDays2021Plot4.lua", },
	[118] = { file="Script/ValentinesDay/2021/TheLittleMermaidBegin.lua", },
	[119] = { file="Script/ValentinesDay/2021/TheLittleMermaidEnd.lua", },
	[120] = { file="Script/ValentinesDay/2021/GulliverSmall.lua", },
	[121] = { file="Script/ValentinesDay/2021/GulliverBig.lua", },
	[122] = { file="Script/ValentinesDay/2021/ValentinesDayMap.lua", },
	[123] = { file="Script/AprilFoolsDay/2021/MagicCardHouse.lua", },
	[145] = { file="Script/Anniversary2021Part2.lua", },
	[146] = { file="Script/Anniversary2021Part1.lua", },
	[147] = { file="Script/Anniversary2021Part2-2.lua", },
	[148] = { file="Script/ChildrenDay/2021/ChildrenNPC2021Part.lua", },
    	[156] = { file="Script/AnniversaryCutBargain.lua", },
	[179] = { file="Script/SummerAct2021.lua", },
	[192] = { file="Script/SummerAct2021DaXuanWo1.lua", },
	[193] = { file="Script/SummerAct2021DaXuanWo2.lua", },
	[194] = { file="Script/SummerAct2021DaXuanWo3.lua", },
	[168] = { file="Script/GhostDreamlandNpc/GhostDreamlandNpc1.lua", },
	[169] = { file="Script/GhostDreamlandNpc/GhostDreamlandNpc2.lua", },
	[190] = { file="Script/ArcherAwakeningWarmUp1.lua", },
	[191] = { file="Script/ArcherAwakeningWarmUp2.lua", },
	[158] = { file="Script/archerstask1.lua", },
	[159] = { file="Script/archerstask2.lua", },
	[160] = { file="Script/archerstask3.lua", },
	[161] = { file="Script/archerstask4.lua", },
	[162] = { file="Script/archerstask5.lua", },
	[163] = { file="Script/archerstask6.lua", },
	[164] = { file="Script/archerstask7.lua", },
	[165] = { file="Script/archerstask8.lua", },
	[166] = { file="Script/archerstask9.lua", },
	[167] = { file="Script/archerstask10.lua", },
	[181] = { file="Script/archerstask11.lua", },
	[182] = { file="Script/archerstask12.lua", },
	[183] = { file="Script/archerstask13.lua", },
	[184] = { file="Script/archerstask14.lua", },
	[185] = { file="Script/archerstask15.lua", },
	[186] = { file="Script/archerstask16.lua", },
	[187] = { file="Script/archerstask17.lua", },
	[188] = { file="Script/archerstask18.lua", },
	[189] = { file="Script/archerstask19.lua", },
	[203] = { file="Script/QiXi2021.lua", },
	[202] = { file="Script/HuangYeDou.lua", },
	[211] = { file="Script/AutumnHunting.lua", },
	[208] = { file="Script/MidAutumnMaze.lua", },
	[209] = { file="Script/Mid-AutumnFestival/2021/Miscellaneous1.lua", },
	[195] = { file="Script/ValleyOfFallen/ValleyOfFallen1.lua", },
	[196] = { file="Script/ValleyOfFallen/ValleyOfFallen2.lua", },
	[197] = { file="Script/ValleyOfFallen/ValleyOfFallen3.lua", },
	[198] = { file="Script/ValleyOfFallen/ValleyOfFallen4.lua", },
	[199] = { file="Script/ValleyOfFallen/ValleyOfFallen5.lua", },
	[200] = { file="Script/ValleyOfFallen/ValleyOfFallen6.lua", },
	[201] = { file="Script/ValleyOfFallen/ValleyOfFallen7.lua", },
	[227] = { file="Script/EgyptCoat.lua", },
	[222] = { file="Script/Halloween/2021/Halloween2021Main.lua", },
	[226] = { file="Script/Halloween/2021/halloweenback.lua", },
	[214] = { file="Script/ColorfulGourd.lua", },
	[230] = { file="Script/ThanksMain2021NPC.lua", },
}

local s_threadScript = nil

-- 启用脚本
local function LoadScript(idScript)
	if (idScript == 0) then
		return
	end

    local tScript = LuaSceneScript[idScript]

    if (tScript == nil) then
        return
    end

	dofile(tScript.file)
	CppScriptMgr:Lua2CScriptEnd()
end

function LuaScriptMgr_BeginScript(idScript)
	if s_threadScript then
		s_threadScript = nil
	end

	s_threadScript = coroutine.create(LoadScript)
	coroutine.resume(s_threadScript, idScript)
end

function LuaScriptMgr_PlayScript()
	if not s_threadScript then
		return
	end

	coroutine.resume(s_threadScript)
end

function LuaScriptMgr_WaitScript()
	if not s_threadScript then
		return
	end

	coroutine.yield(s_threadScript)
end

function LuaScriptMgr_EndScript()
	s_threadScript = nil
end

local DLG_CAN_SHOW = {
[958] = true,
[966] = true,
}

-- 脚本剧情中是否可显示窗口
function LuaScriptMgr_IsDlgCanShow(id)
    local ret = DLG_CAN_SHOW[id]

    if (ret == nil) then
        return false
    end

    return ret
end

function LuaScriptMgr_Unload()
    DLG_CAN_SHOW = nil
end

function LuaScriptMgr_GetScript(id)
    local tScript = LuaSceneScript[id]

    if (tScript == nil) then
        return ""
    end

    return tScript.file
end
